XYZ File Manager
Current Path:
/usr/bin
usr
/
bin
/
π
..
π
X11
π
[
(66.89 KB)
π
ab
(58.42 KB)
π
addpart
(30.31 KB)
π
apt
(18.31 KB)
π
apt-cache
(86.38 KB)
π
apt-cdrom
(22.38 KB)
π
apt-config
(26.31 KB)
π
apt-get
(50.38 KB)
π
apt-key
(27.32 KB)
π
apt-mark
(58.38 KB)
π
arch
(42.86 KB)
π
awk
(154.66 KB)
π
b2sum
(58.98 KB)
π
base32
(46.89 KB)
π
base64
(46.89 KB)
π
basename
(42.83 KB)
π
basenc
(54.89 KB)
π
bash
(1.21 MB)
π
bashbug
(6.7 KB)
π
bdftopcf
(42.45 KB)
π
bdftruncate
(10.22 KB)
π
busctl
(90.5 KB)
π
c_rehash
(6.68 KB)
π
captoinfo
(90.34 KB)
π
cat
(42.98 KB)
π
certbot
(958 B)
π
chage
(78.49 KB)
π
chardet
(221 B)
π
chardetect
(221 B)
π
chattr
(14.24 KB)
π
chcon
(67.11 KB)
π
checkgid
(14.23 KB)
π
chfn
(61.2 KB)
π
chgrp
(67.05 KB)
π
chmod
(62.98 KB)
π
choom
(54.31 KB)
π
chown
(71.05 KB)
π
chrt
(66.31 KB)
π
chsh
(51.64 KB)
π
cksum
(139.05 KB)
π
clear
(14.24 KB)
π
clear_console
(14.15 KB)
π
cmp
(50.95 KB)
π
comm
(46.92 KB)
π
corelist
(15.01 KB)
π
cp
(147.61 KB)
π
cpan
(8.16 KB)
π
cpan5.36-x86_64-linux-gnu
(8.18 KB)
π
csplit
(119.17 KB)
π
ctstat
(26.59 KB)
π
cut
(46.98 KB)
π
dash
(122.7 KB)
π
date
(119.05 KB)
π
dbus-cleanup-sockets
(14.22 KB)
π
dbus-daemon
(238.56 KB)
π
dbus-monitor
(26.23 KB)
π
dbus-run-session
(14.23 KB)
π
dbus-send
(30.22 KB)
π
dbus-update-activation-environment
(14.22 KB)
π
dbus-uuidgen
(14.22 KB)
π
dd
(87.15 KB)
π
deb-systemd-helper
(23.79 KB)
π
deb-systemd-invoke
(6.09 KB)
π
debconf
(2.79 KB)
π
debconf-apt-progress
(11.27 KB)
π
debconf-communicate
(608 B)
π
debconf-copydb
(1.68 KB)
π
debconf-escape
(647 B)
π
debconf-set-selections
(2.92 KB)
π
debconf-show
(1.78 KB)
π
delpart
(30.31 KB)
π
df
(99.8 KB)
π
dialog
(247.85 KB)
π
diff
(151.58 KB)
π
diff3
(67.14 KB)
π
dir
(147.8 KB)
π
dircolors
(50.92 KB)
π
dirname
(38.83 KB)
π
dmesg
(86.58 KB)
π
dnsdomainname
(22.15 KB)
π
domainname
(22.15 KB)
π
dpkg
(310.64 KB)
π
dpkg-deb
(166.52 KB)
π
dpkg-divert
(154.55 KB)
π
dpkg-maintscript-helper
(20.71 KB)
π
dpkg-query
(158.58 KB)
π
dpkg-realpath
(4.09 KB)
π
dpkg-split
(126.48 KB)
π
dpkg-statoverride
(62.33 KB)
π
dpkg-trigger
(86.48 KB)
π
du
(171.33 KB)
π
dvipdf
(1007 B)
π
echo
(42.83 KB)
π
editor
(3.48 MB)
π
egrep
(41 B)
π
enc2xs
(40.96 KB)
π
encguess
(3 KB)
π
env
(47.4 KB)
π
eps2eps
(639 B)
π
ex
(3.48 MB)
π
expand
(42.92 KB)
π
expiry
(30.45 KB)
π
expr
(115.05 KB)
π
factor
(83.2 KB)
π
faillog
(22.53 KB)
π
fallocate
(34.31 KB)
π
false
(34.83 KB)
π
fcgistarter
(14.23 KB)
π
fgrep
(41 B)
π
fincore
(34.36 KB)
π
find
(219.58 KB)
π
findmnt
(83.59 KB)
π
flock
(34.39 KB)
π
fmt
(46.89 KB)
π
fold
(42.89 KB)
π
fonttosfnt
(34.41 KB)
π
free
(26.3 KB)
π
fuser
(39.83 KB)
π
getconf
(26.5 KB)
π
getent
(35.47 KB)
π
getopt
(34.31 KB)
π
ghostscript
(14.23 KB)
π
gpasswd
(86.42 KB)
π
gpgv
(463 KB)
π
grep
(198.39 KB)
π
groups
(42.89 KB)
π
gs
(14.23 KB)
π
gsbj
(350 B)
π
gsdj
(352 B)
π
gsdj500
(352 B)
π
gslj
(353 B)
π
gslp
(350 B)
π
gsnd
(277 B)
π
gunzip
(2.29 KB)
π
gzexe
(6.3 KB)
π
gzip
(95.84 KB)
π
h2ph
(28.54 KB)
π
h2xs
(59.51 KB)
π
hardlink
(50.39 KB)
π
head
(46.95 KB)
π
helpztags
(2.46 KB)
π
hostid
(38.83 KB)
π
hostname
(22.15 KB)
π
hostnamectl
(30.38 KB)
π
htcacheclean
(34.24 KB)
π
htdbm
(26.23 KB)
π
htdigest
(14.23 KB)
π
htpasswd
(26.23 KB)
π
i386
(26.58 KB)
π
iconv
(63.13 KB)
π
id
(47.02 KB)
π
infocmp
(62.31 KB)
π
infotocap
(90.34 KB)
π
install
(155.8 KB)
π
instmodsh
(4.27 KB)
π
ionice
(34.31 KB)
π
ip
(674.82 KB)
π
ipcmk
(34.38 KB)
π
ipcrm
(34.31 KB)
π
ipcs
(74.31 KB)
π
ischroot
(14.32 KB)
π
join
(54.98 KB)
π
journalctl
(74.64 KB)
π
json_pp
(4.88 KB)
π
kernel-install
(12.75 KB)
π
kill
(22.3 KB)
π
killall
(31.95 KB)
π
last
(50.31 KB)
π
lastb
(50.31 KB)
π
lastlog
(31.75 KB)
π
lcf
(7.6 KB)
π
ld.so
(205.96 KB)
π
ldd
(5.28 KB)
π
letsencrypt
(958 B)
π
libnetcfg
(15.41 KB)
π
link
(38.83 KB)
π
linux32
(26.58 KB)
π
linux64
(26.58 KB)
π
ln
(71.12 KB)
π
lnstat
(26.59 KB)
π
locale
(46.16 KB)
π
localectl
(26.38 KB)
π
localedef
(291.91 KB)
π
logger
(54.9 KB)
π
login
(51.78 KB)
π
loginctl
(58.48 KB)
π
logname
(38.83 KB)
π
logresolve
(14.24 KB)
π
ls
(147.8 KB)
π
lsattr
(14.24 KB)
π
lsb_release
(2.59 KB)
π
lsblk
(202.31 KB)
π
lscpu
(126.31 KB)
π
lsfd
(120.3 KB)
π
lsipc
(98.31 KB)
π
lsirq
(34.48 KB)
π
lslocks
(70.7 KB)
π
lslogins
(94.31 KB)
π
lsmem
(66.31 KB)
π
lsns
(82.31 KB)
π
mawk
(154.66 KB)
π
mcookie
(34.38 KB)
π
md5sum
(50.95 KB)
π
md5sum.textutils
(50.95 KB)
π
mesg
(18.3 KB)
π
mkdir
(95.27 KB)
π
mkfifo
(67.17 KB)
π
mkfontdir
(65 B)
π
mkfontscale
(39.05 KB)
π
mknod
(71.2 KB)
π
mktemp
(42.92 KB)
π
more
(58.31 KB)
π
mount
(58.3 KB)
π
mountpoint
(18.3 KB)
π
mv
(139.62 KB)
π
namei
(34.31 KB)
π
nawk
(154.66 KB)
π
netstat
(151.66 KB)
π
networkctl
(106.38 KB)
π
newgrp
(47.75 KB)
π
nice
(42.86 KB)
π
nisdomainname
(22.15 KB)
π
nl
(111.11 KB)
π
nohup
(42.89 KB)
π
normalizer
(244 B)
π
nproc
(42.89 KB)
π
nsenter
(34.54 KB)
π
nstat
(104.45 KB)
π
numfmt
(67.02 KB)
π
od
(79.02 KB)
π
openssl
(953.26 KB)
π
pager
(58.31 KB)
π
paperconf
(14.34 KB)
π
partx
(118.31 KB)
π
passwd
(66.65 KB)
π
paste
(42.89 KB)
π
pathchk
(42.86 KB)
π
pdb3
(62.4 KB)
π
pdb3.11
(62.4 KB)
π
pdf2dsc
(698 B)
π
pdf2ps
(909 B)
π
peekfd
(14.5 KB)
π
perl
(3.63 MB)
π
perl5.36-x86_64-linux-gnu
(14.41 KB)
π
perl5.36.0
(3.63 MB)
π
perlbug
(44.12 KB)
π
perldoc
(125 B)
π
perlivp
(10.61 KB)
π
perlthanks
(44.12 KB)
π
pf2afm
(498 B)
π
pfbtopfa
(516 B)
π
pgrep
(34.42 KB)
π
phar
(14.88 KB)
π
phar.phar
(14.88 KB)
π
phar.phar8.2
(14.88 KB)
π
phar8.2
(14.88 KB)
π
phar8.2.phar
(14.88 KB)
π
php
(5.4 MB)
π
php8.2
(5.4 MB)
π
piconv
(8.16 KB)
π
pidof
(26.31 KB)
π
pidwait
(34.42 KB)
π
pinky
(47.05 KB)
π
pkill
(34.42 KB)
π
pl2pm
(4.43 KB)
π
pldd
(22.69 KB)
π
pmap
(34.34 KB)
π
pod2html
(4.04 KB)
π
pod2man
(14.68 KB)
π
pod2text
(10.55 KB)
π
pod2usage
(4.01 KB)
π
podchecker
(3.57 KB)
π
pphs
(404 B)
π
pr
(79.11 KB)
π
printafm
(395 B)
π
printenv
(34.83 KB)
π
printf
(62.92 KB)
π
prlimit
(38.83 KB)
π
prove
(13.34 KB)
π
prtstat
(18.57 KB)
π
ps
(142.93 KB)
π
ps2ascii
(631 B)
π
ps2epsi
(1.23 KB)
π
ps2pdf
(272 B)
π
ps2pdf12
(215 B)
π
ps2pdf13
(215 B)
π
ps2pdf14
(215 B)
π
ps2pdfwr
(1.05 KB)
π
ps2ps
(647 B)
π
ps2ps2
(669 B)
π
ps2txt
(631 B)
π
pslog
(14.45 KB)
π
pstree
(35.78 KB)
π
pstree.x11
(35.78 KB)
π
ptar
(3.48 KB)
π
ptardiff
(2.58 KB)
π
ptargrep
(4.29 KB)
π
ptx
(135.23 KB)
π
pwd
(42.92 KB)
π
pwdx
(14.3 KB)
π
py3clean
(7.63 KB)
π
py3compile
(13 KB)
π
py3versions
(12.52 KB)
π
pydoc3
(79 B)
π
pydoc3.11
(79 B)
π
pygettext3
(23.67 KB)
π
pygettext3.11
(23.67 KB)
π
python3
(6.52 MB)
π
python3.11
(6.52 MB)
π
rbash
(1.21 MB)
π
rdma
(180.6 KB)
π
readlink
(50.89 KB)
π
realpath
(50.92 KB)
π
rename.ul
(22.3 KB)
π
renice
(14.3 KB)
π
reset
(30.24 KB)
π
resizepart
(70.31 KB)
π
rev
(14.3 KB)
π
rgrep
(30 B)
π
rm
(71.05 KB)
π
rmdir
(54.92 KB)
π
rotatelogs
(26.31 KB)
π
routel
(1.62 KB)
π
rtstat
(26.59 KB)
π
run-parts
(26.91 KB)
π
runcon
(42.95 KB)
π
rview
(3.48 MB)
π
rvim
(3.48 MB)
π
savelog
(10.24 KB)
π
scp
(266.63 KB)
π
script
(70.3 KB)
π
scriptlive
(54.3 KB)
π
scriptreplay
(46.3 KB)
π
sdiff
(55.08 KB)
π
sed
(123.46 KB)
π
select-editor
(2.39 KB)
π
sensible-browser
(1.26 KB)
π
sensible-editor
(1.24 KB)
π
sensible-pager
(565 B)
π
seq
(58.92 KB)
π
setarch
(26.58 KB)
π
setpriv
(78.31 KB)
π
setsid
(14.3 KB)
π
setterm
(46.31 KB)
π
sftp
(282.59 KB)
π
sg
(47.75 KB)
π
sh
(122.7 KB)
π
sha1sum
(54.95 KB)
π
sha224sum
(58.95 KB)
π
sha256sum
(58.95 KB)
π
sha384sum
(62.95 KB)
π
sha512sum
(62.95 KB)
π
shasum
(9.75 KB)
π
shred
(63.14 KB)
π
shuf
(58.98 KB)
π
skill
(30.33 KB)
π
slabtop
(22.37 KB)
π
sleep
(42.86 KB)
π
slogin
(1.07 MB)
π
snice
(30.33 KB)
π
sort
(115.68 KB)
π
splain
(18.99 KB)
π
split
(59.55 KB)
π
ss
(189.14 KB)
π
ssh
(1.07 MB)
π
ssh-add
(518.44 KB)
π
ssh-agent
(474.38 KB)
π
ssh-argv0
(1.42 KB)
π
ssh-copy-id
(12.38 KB)
π
ssh-keygen
(646.44 KB)
π
ssh-keyscan
(622.47 KB)
π
stat
(95.2 KB)
π
stdbuf
(58.92 KB)
π
streamzip
(7.75 KB)
π
stty
(83.02 KB)
π
su
(70.31 KB)
π
sum
(50.96 KB)
π
sync
(38.89 KB)
π
systemctl
(1.29 MB)
π
systemd
(90.38 KB)
π
systemd-analyze
(182.61 KB)
π
systemd-ask-password
(18.48 KB)
π
systemd-cat
(18.38 KB)
π
systemd-cgls
(22.48 KB)
π
systemd-cgtop
(38.4 KB)
π
systemd-creds
(42.61 KB)
π
systemd-cryptenroll
(58.6 KB)
π
systemd-delta
(26.38 KB)
π
systemd-detect-virt
(18.37 KB)
π
systemd-escape
(18.37 KB)
π
systemd-firstboot
(50.59 KB)
π
systemd-id128
(22.37 KB)
π
systemd-inhibit
(22.39 KB)
π
systemd-machine-id-setup
(18.48 KB)
π
systemd-mount
(50.59 KB)
π
systemd-notify
(18.38 KB)
π
systemd-path
(18.37 KB)
π
systemd-repart
(150.69 KB)
π
systemd-run
(58.57 KB)
π
systemd-socket-activate
(26.38 KB)
π
systemd-stdio-bridge
(18.38 KB)
π
systemd-sysext
(42.49 KB)
π
systemd-sysusers
(62.68 KB)
π
systemd-tmpfiles
(110.57 KB)
π
systemd-tty-ask-password-agent
(34.38 KB)
π
systemd-umount
(50.59 KB)
π
tabs
(18.23 KB)
π
tac
(111.05 KB)
π
tail
(75.14 KB)
π
tar
(519.52 KB)
π
taskset
(62.31 KB)
π
tee
(42.95 KB)
π
tempfile
(14.18 KB)
π
test
(58.89 KB)
π
tic
(90.34 KB)
π
timedatectl
(42.37 KB)
π
timeout
(47.49 KB)
π
tload
(18.32 KB)
π
toe
(22.23 KB)
π
top
(131.58 KB)
π
touch
(107.05 KB)
π
tput
(26.27 KB)
π
tr
(54.89 KB)
π
true
(34.83 KB)
π
truncate
(42.89 KB)
π
tset
(30.24 KB)
π
tsort
(54.89 KB)
π
tty
(34.86 KB)
π
tzselect
(14.99 KB)
π
ucf
(40.69 KB)
π
ucfq
(18.91 KB)
π
ucfr
(10.85 KB)
π
uclampset
(62.31 KB)
π
ucs2any
(18.32 KB)
π
umount
(34.3 KB)
π
uname
(42.86 KB)
π
uncompress
(2.29 KB)
π
unexpand
(42.92 KB)
π
uniq
(46.95 KB)
π
unlink
(38.83 KB)
π
unshare
(82.54 KB)
π
update-alternatives
(58.31 KB)
π
update-mime-database
(59.27 KB)
π
uptime
(14.3 KB)
π
users
(38.89 KB)
π
utmpdump
(30.3 KB)
π
vdir
(147.8 KB)
π
vi
(3.48 MB)
π
view
(3.48 MB)
π
vim
(3.48 MB)
π
vim.basic
(3.48 MB)
π
vimdiff
(3.48 MB)
π
vimtutor
(2.1 KB)
π
vmstat
(34.72 KB)
π
w
(22.3 KB)
π
wall
(38.3 KB)
π
watch
(26.71 KB)
π
wc
(51.05 KB)
π
wdctl
(70.34 KB)
π
wget
(527.36 KB)
π
whereis
(30.77 KB)
π
which
(946 B)
π
which.debianutils
(946 B)
π
who
(59.02 KB)
π
whoami
(38.86 KB)
π
x86_64
(26.58 KB)
π
xargs
(70.45 KB)
π
xdg-user-dir
(234 B)
π
xdg-user-dirs-update
(26.16 KB)
π
xsubpp
(5.05 KB)
π
xxd
(18.21 KB)
π
yes
(38.83 KB)
π
ypdomainname
(22.15 KB)
π
zcat
(1.94 KB)
π
zcmp
(1.64 KB)
π
zdiff
(6.31 KB)
π
zdump
(22.52 KB)
π
zegrep
(29 B)
π
zfgrep
(29 B)
π
zforce
(2.03 KB)
π
zgrep
(7.91 KB)
π
zipdetails
(68.55 KB)
π
zless
(2.15 KB)
π
zmore
(1.8 KB)
π
znew
(4.47 KB)
Editing: dpkg-maintscript-helper
#!/bin/sh # # Copyright Β© 2007, 2011-2015 Guillem Jover <guillem@debian.org> # Copyright Β© 2010 RaphaΓ«l Hertzog <hertzog@debian.org> # Copyright Β© 2008 Joey Hess <joeyh@debian.org> # Copyright Β© 2005 Scott James Remnant (original implementation on www.dpkg.org) # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; either version 2 of the License, or # (at your option) any later version. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program. If not, see <https://www.gnu.org/licenses/>. # The conffile related functions are inspired by # https://wiki.debian.org/DpkgConffileHandling # This script is documented in dpkg-maintscript-helper(1) ## ## Functions to remove an obsolete conffile during upgrade ## rm_conffile() { local CONFFILE="$1" local LASTVERSION="$2" local PACKAGE="$3" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$PACKAGE" ] || error "couldn't identify the package" [ -n "$1" ] || error "maintainer script parameters are missing" [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ "${CONFFILE}" != "${CONFFILE#/}" ] || \ error "conffile '$CONFFILE' is not an absolute path" validate_optional_version "$LASTVERSION" debug "Executing $0 rm_conffile in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "CONFFILE=$CONFFILE PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_rm_conffile "$CONFFILE" "$PACKAGE" fi ;; postinst) if [ "$1" = "configure" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then finish_rm_conffile "$CONFFILE" fi ;; postrm) if [ "$1" = "purge" ]; then rm -f "$DPKG_ROOT$CONFFILE.dpkg-bak" \ "$DPKG_ROOT$CONFFILE.dpkg-remove" \ "$DPKG_ROOT$CONFFILE.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_rm_conffile "$CONFFILE" "$PACKAGE" fi ;; *) debug "$0 rm_conffile not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_rm_conffile() { local CONFFILE="$1" local PACKAGE="$2" [ -e "$DPKG_ROOT$CONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 local md5sum old_md5sum md5sum="$(md5sum "$DPKG_ROOT$CONFFILE" | sed -e 's/ .*//')" old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \ sed -n -e "\\'^ $CONFFILE ' { s/ obsolete$//; s/.* //; p }")" if [ "$md5sum" != "$old_md5sum" ]; then mv -f "$DPKG_ROOT$CONFFILE" "$DPKG_ROOT$CONFFILE.dpkg-backup" else mv -f "$DPKG_ROOT$CONFFILE" "$DPKG_ROOT$CONFFILE.dpkg-remove" fi } finish_rm_conffile() { local CONFFILE="$1" if [ -e "$DPKG_ROOT$CONFFILE.dpkg-backup" ]; then echo "Obsolete conffile $DPKG_ROOT$CONFFILE has been modified by you." echo "Saving as $DPKG_ROOT$CONFFILE.dpkg-bak ..." mv -f "$DPKG_ROOT$CONFFILE.dpkg-backup" "$DPKG_ROOT$CONFFILE.dpkg-bak" fi if [ -e "$DPKG_ROOT$CONFFILE.dpkg-remove" ]; then echo "Removing obsolete conffile $DPKG_ROOT$CONFFILE ..." rm -f "$DPKG_ROOT$CONFFILE.dpkg-remove" fi } abort_rm_conffile() { local CONFFILE="$1" local PACKAGE="$2" ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 if [ -e "$DPKG_ROOT$CONFFILE.dpkg-remove" ]; then echo "Reinstalling $DPKG_ROOT$CONFFILE that was moved away" mv "$DPKG_ROOT$CONFFILE.dpkg-remove" "$DPKG_ROOT$CONFFILE" fi if [ -e "$DPKG_ROOT$CONFFILE.dpkg-backup" ]; then echo "Reinstalling $DPKG_ROOT$CONFFILE that was backed-up" mv "$DPKG_ROOT$CONFFILE.dpkg-backup" "$DPKG_ROOT$CONFFILE" fi } ## ## Functions to rename a conffile during upgrade ## mv_conffile() { local OLDCONFFILE="$1" local NEWCONFFILE="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$PACKAGE" ] || error "couldn't identify the package" [ -n "$1" ] || error "maintainer script parameters are missing" [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ "${OLDCONFFILE}" != "${OLDCONFFILE#/}" ] || \ error "old-conffile '$OLDCONFFILE' is not an absolute path" [ "${NEWCONFFILE}" != "${NEWCONFFILE#/}" ] || \ error "new-conffile '$NEWCONFFILE' is not an absolute path" validate_optional_version "$LASTVERSION" debug "Executing $0 mv_conffile in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "CONFFILE=$OLDCONFFILE -> $NEWCONFFILE PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_mv_conffile "$OLDCONFFILE" "$PACKAGE" fi ;; postinst) if [ "$1" = "configure" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then finish_mv_conffile "$OLDCONFFILE" "$NEWCONFFILE" "$PACKAGE" fi ;; postrm) if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_mv_conffile "$OLDCONFFILE" "$PACKAGE" fi ;; *) debug "$0 mv_conffile not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_mv_conffile() { local CONFFILE="$1" local PACKAGE="$2" [ -e "$DPKG_ROOT$CONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 local md5sum old_md5sum md5sum="$(md5sum "$DPKG_ROOT$CONFFILE" | sed -e 's/ .*//')" old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$PACKAGE" | \ sed -n -e "\\'^ $CONFFILE ' { s/ obsolete$//; s/.* //; p }")" if [ "$md5sum" = "$old_md5sum" ]; then mv -f "$DPKG_ROOT$CONFFILE" "$DPKG_ROOT$CONFFILE.dpkg-remove" fi } finish_mv_conffile() { local OLDCONFFILE="$1" local NEWCONFFILE="$2" local PACKAGE="$3" rm -f "$DPKG_ROOT$OLDCONFFILE.dpkg-remove" [ -e "$DPKG_ROOT$OLDCONFFILE" ] || return 0 ensure_package_owns_file "$PACKAGE" "$OLDCONFFILE" || return 0 echo "Preserving user changes to $DPKG_ROOT$NEWCONFFILE (renamed from $DPKG_ROOT$OLDCONFFILE)..." if [ -e "$DPKG_ROOT$NEWCONFFILE" ]; then mv -f "$DPKG_ROOT$NEWCONFFILE" "$DPKG_ROOT$NEWCONFFILE.dpkg-new" fi mv -f "$DPKG_ROOT$OLDCONFFILE" "$DPKG_ROOT$NEWCONFFILE" } abort_mv_conffile() { local CONFFILE="$1" local PACKAGE="$2" ensure_package_owns_file "$PACKAGE" "$CONFFILE" || return 0 if [ -e "$DPKG_ROOT$CONFFILE.dpkg-remove" ]; then echo "Reinstalling $DPKG_ROOT$CONFFILE that was moved away" mv "$DPKG_ROOT$CONFFILE.dpkg-remove" "$DPKG_ROOT$CONFFILE" fi } ## ## Functions to replace a symlink with a directory ## symlink_to_dir() { local SYMLINK="$1" local SYMLINK_TARGET="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ -n "$PACKAGE" ] || error "cannot identify the package" [ -n "$SYMLINK" ] || error "symlink parameter is missing" [ "${SYMLINK#/}" = "$SYMLINK" ] && \ error "symlink pathname is not an absolute path" [ "${SYMLINK%/}" = "$SYMLINK" ] || \ error "symlink pathname ends with a slash" [ -n "$SYMLINK_TARGET" ] || error "original symlink target is missing" [ -n "$1" ] || error "maintainer script parameters are missing" validate_optional_version "$LASTVERSION" debug "Executing $0 symlink_to_dir in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "SYMLINK=$SYMLINK -> $SYMLINK_TARGET PACKAGE=$PACKAGE" \ "LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && [ -h "$DPKG_ROOT$SYMLINK" ] && symlink_match "$SYMLINK" "$SYMLINK_TARGET" && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then mv -f "$DPKG_ROOT$SYMLINK" "$DPKG_ROOT${SYMLINK}.dpkg-backup" fi ;; postinst) # We cannot bail depending on the version, as here we only # know what was the last configured version, and we might # have been unpacked, then upgraded with an unpack and thus # never been configured before. if [ "$1" = "configure" ] && [ -h "$DPKG_ROOT${SYMLINK}.dpkg-backup" ] && symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" then rm -f "$DPKG_ROOT${SYMLINK}.dpkg-backup" fi ;; postrm) if [ "$1" = "purge" ] && [ -h "$DPKG_ROOT${SYMLINK}.dpkg-backup" ]; then rm -f "$DPKG_ROOT${SYMLINK}.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && [ ! -e "$DPKG_ROOT$SYMLINK" ] && [ -h "$DPKG_ROOT${SYMLINK}.dpkg-backup" ] && symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then echo "Restoring backup of $DPKG_ROOT$SYMLINK ..." mv "$DPKG_ROOT${SYMLINK}.dpkg-backup" "$DPKG_ROOT$SYMLINK" fi ;; *) debug "$0 symlink_to_dir not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } ## ## Functions to replace a directory with a symlink ## dir_to_symlink() { local PATHNAME="${1%/}" local SYMLINK_TARGET="$2" local LASTVERSION="$3" local PACKAGE="$4" if [ "$LASTVERSION" = "--" ]; then LASTVERSION="" PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi if [ "$PACKAGE" = "--" -o -z "$PACKAGE" ]; then PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE${DPKG_MAINTSCRIPT_ARCH:+:$DPKG_MAINTSCRIPT_ARCH}" fi # Skip remaining parameters up to -- while [ "$1" != "--" -a $# -gt 0 ]; do shift done [ $# -gt 0 ] || badusage "missing arguments after --" shift [ -n "$DPKG_MAINTSCRIPT_NAME" ] || \ error "environment variable DPKG_MAINTSCRIPT_NAME is required" [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] || \ error "environment variable DPKG_MAINTSCRIPT_PACKAGE is required" [ -n "$PACKAGE" ] || error "cannot identify the package" [ -n "$PATHNAME" ] || error "directory parameter is missing" [ "${PATHNAME#/}" = "$PATHNAME" ] && \ error "directory parameter is not an absolute path" [ -n "$SYMLINK_TARGET" ] || error "new symlink target is missing" [ -n "$1" ] || error "maintainer script parameters are missing" validate_optional_version "$LASTVERSION" debug "Executing $0 dir_to_symlink in $DPKG_MAINTSCRIPT_NAME" \ "of $DPKG_MAINTSCRIPT_PACKAGE" debug "PATHNAME=$PATHNAME SYMLINK_TARGET=$SYMLINK_TARGET" \ "PACKAGE=$PACKAGE LASTVERSION=$LASTVERSION ACTION=$1 PARAM=$2" case "$DPKG_MAINTSCRIPT_NAME" in preinst) if [ "$1" = "install" -o "$1" = "upgrade" ] && [ -n "$2" ] && [ ! -h "$DPKG_ROOT$PATHNAME" ] && [ -d "$DPKG_ROOT$PATHNAME" ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then prepare_dir_to_symlink "$PACKAGE" "$PATHNAME" fi ;; postinst) # We cannot bail depending on the version, as here we only # know what was the last configured version, and we might # have been unpacked, then upgraded with an unpack and thus # never been configured before. if [ "$1" = "configure" ] && [ -d "$DPKG_ROOT${PATHNAME}.dpkg-backup" ] && [ ! -h "$DPKG_ROOT$PATHNAME" ] && [ -d "$DPKG_ROOT$PATHNAME" ] && [ -f "$DPKG_ROOT$PATHNAME/.dpkg-staging-dir" ]; then finish_dir_to_symlink "$PATHNAME" "$SYMLINK_TARGET" fi ;; postrm) if [ "$1" = "purge" ] && [ -d "$DPKG_ROOT${PATHNAME}.dpkg-backup" ]; then rm -rf "$DPKG_ROOT${PATHNAME}.dpkg-backup" fi if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] && [ -n "$2" ] && [ -d "$DPKG_ROOT${PATHNAME}.dpkg-backup" ] && [ \( ! -h "$DPKG_ROOT$PATHNAME" -a \ -d "$DPKG_ROOT$PATHNAME" -a \ -f "$DPKG_ROOT$PATHNAME/.dpkg-staging-dir" \) -o \ \( -h "$DPKG_ROOT$PATHNAME" -a \ \( "$(readlink "$DPKG_ROOT$PATHNAME")" = "$SYMLINK_TARGET" -o \ "$(dpkg-realpath "$PATHNAME")" = "$SYMLINK_TARGET" \) \) ] && dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then abort_dir_to_symlink "$PATHNAME" fi ;; *) debug "$0 dir_to_symlink not required in $DPKG_MAINTSCRIPT_NAME" ;; esac } prepare_dir_to_symlink() { local PACKAGE="$1" local PATHNAME="$2" local LINE # If there are conffiles we should not perform the switch. dpkg-query -W -f='${Conffiles}\n' "$PACKAGE" | while read -r LINE; do case "$LINE" in "$PATHNAME"/*) error "directory '$PATHNAME' contains conffiles," \ "cannot switch to symlink" ;; esac done # If there are locally created files or files owned by another package # we should not perform the switch. export DPKG_MAINTSCRIPT_HELPER_INTERNAL_API="$version" find "$DPKG_ROOT$PATHNAME" -print0 | \ xargs -0 -n1 "$0" _internal_pkg_must_own_file "$PACKAGE" || \ error "directory '$PATHNAME' contains files not owned by" \ "package $PACKAGE, cannot switch to symlink" unset DPKG_MAINTSCRIPT_HELPER_INTERNAL_API # At this point, we know that the directory either contains no files, # or only non-conffiles owned by the package. # # To do the switch we cannot simply replace it with the final symlink # just yet, because dpkg needs to remove any file present in the old # package that have disappeared in the new one, and we do not want to # lose files resolving to the same pathname in the symlink target. # # We cannot replace the directory with a staging symlink either, # because dpkg will update symlinks to their new target. # # So we need to create a staging directory, to avoid removing files # from other packages, and to trap any new files in the directory # to move them to their correct place later on. mv -f "$DPKG_ROOT$PATHNAME" "$DPKG_ROOT${PATHNAME}.dpkg-backup" mkdir "$DPKG_ROOT$PATHNAME" # Mark it as a staging directory, so that we can track things. touch "$DPKG_ROOT$PATHNAME/.dpkg-staging-dir" } finish_dir_to_symlink() { local PATHNAME="$1" local SYMLINK_TARGET="$2" # Move the contents of the staging directory to the symlink target, # as those are all new files installed between this package being # unpacked and configured. local ABS_SYMLINK_TARGET if [ "${SYMLINK_TARGET#/}" = "$SYMLINK_TARGET" ]; then ABS_SYMLINK_TARGET="$(dirname "$PATHNAME")/$SYMLINK_TARGET" else ABS_SYMLINK_TARGET="$SYMLINK_TARGET" fi rm "$DPKG_ROOT$PATHNAME/.dpkg-staging-dir" find "$DPKG_ROOT$PATHNAME" -mindepth 1 -maxdepth 1 -print0 | \ xargs -0 -I% mv -f "%" "$DPKG_ROOT$ABS_SYMLINK_TARGET/" # Remove the staging directory. rmdir "$DPKG_ROOT$PATHNAME" # Do the actual switch. ln -s "$SYMLINK_TARGET" "$DPKG_ROOT$PATHNAME" # We are left behind the old files owned by this package in the backup # directory, just remove it. rm -rf "$DPKG_ROOT${PATHNAME}.dpkg-backup" } abort_dir_to_symlink() { local PATHNAME="$1" echo "Restoring backup of $DPKG_ROOT$PATHNAME ..." if [ -h "$DPKG_ROOT$PATHNAME" ]; then rm -f "$DPKG_ROOT$PATHNAME" else # The staging directory must be empty, as no other package # should have been unpacked in between. rm -f "$DPKG_ROOT$PATHNAME/.dpkg-staging-dir" rmdir "$DPKG_ROOT$PATHNAME" fi mv "$DPKG_ROOT${PATHNAME}.dpkg-backup" "$DPKG_ROOT$PATHNAME" } # Common functions validate_optional_version() { local VERSION="$1" if [ -z "$VERSION" ]; then return fi if ! VERSIONCHECK=$(dpkg --validate-version -- "$VERSION" 2>&1); then error "$VERSIONCHECK" fi } ensure_package_owns_file() { local PACKAGE="$1" local FILE="$2" if ! dpkg-query -L "$PACKAGE" | grep -F -q -x "$FILE"; then debug "File '$FILE' not owned by package " \ "'$PACKAGE', skipping $command" return 1 fi return 0 } internal_pkg_must_own_file() { local PACKAGE="$1" local FILE="${2##"$DPKG_ROOT"}" if [ "$DPKG_MAINTSCRIPT_HELPER_INTERNAL_API" != "$version" ]; then error "internal API used by external command" fi if ! ensure_package_owns_file "$PACKAGE" "$FILE"; then error "file '$FILE' not owned by package '$PACKAGE'" fi return 0 } symlink_match() { local SYMLINK="$1" local SYMLINK_TARGET="$2" [ "$(readlink "$DPKG_ROOT$SYMLINK")" = "$SYMLINK_TARGET" ] || \ [ "$(dpkg-realpath "$SYMLINK")" = "$SYMLINK_TARGET" ] } usage() { cat <<END Usage: $PROGNAME <command> <parameter>... -- <maintainer-script-parameter>... Commands: supports <command> Returns 0 (success) if the given command is supported, 1 otherwise. rm_conffile <conffile> [<last-version> [<package>]] Remove obsolete conffile. Must be called in preinst, postinst and postrm. mv_conffile <old-conf> <new-conf> [<last-version> [<package>]] Rename a conffile. Must be called in preinst, postinst and postrm. symlink_to_dir <pathname> <old-symlink-target> [<last-version> [<package>]] Replace a symlink with a directory. Must be called in preinst, postinst and postrm. dir_to_symlink <pathname> <new-symlink-target> [<last-version> [<package>]] Replace a directory with a symlink. Must be called in preinst, postinst and postrm. help -?, --help Show this help message. --version Show the version. END } # Main code set -e PROGNAME=$(basename "$0") version="1.21.22" DPKG_ROOT=${DPKG_ROOT:+$(realpath "$DPKG_ROOT")} # Remove default root dir. if [ "$DPKG_ROOT" = "/" ]; then DPKG_ROOT="" fi export DPKG_ROOT PKGDATADIR_DEFAULT='/usr/share/dpkg' PKGDATADIR="${DPKG_DATADIR:-$PKGDATADIR_DEFAULT}" # shellcheck source=src/sh/dpkg-error.sh . "$PKGDATADIR/sh/dpkg-error.sh" setup_colors command="$1" [ $# -gt 0 ] || badusage "missing command" shift case "$command" in supports) case "$1" in rm_conffile|mv_conffile|symlink_to_dir|dir_to_symlink) code=0 ;; *) code=1 ;; esac if [ -z "$DPKG_MAINTSCRIPT_NAME" ]; then warning "environment variable DPKG_MAINTSCRIPT_NAME missing" code=1 fi if [ -z "$DPKG_MAINTSCRIPT_PACKAGE" ]; then warning "environment variable DPKG_MAINTSCRIPT_PACKAGE missing" code=1 fi exit $code ;; rm_conffile) rm_conffile "$@" ;; mv_conffile) mv_conffile "$@" ;; symlink_to_dir) symlink_to_dir "$@" ;; dir_to_symlink) dir_to_symlink "$@" ;; _internal_pkg_must_own_file) # This is an internal command, must not be used outside this program. internal_pkg_must_own_file "$@" ;; --help|help|-?) usage ;; --version) cat <<END Debian $PROGNAME version $version. This is free software; see the GNU General Public License version 2 or later for copying conditions. There is NO warranty. END ;; *) badusage "command $command is unknown Hint: upgrading dpkg to a newer version might help." esac exit 0
Upload File
Create Folder